// Only for not commercial use!
// by RHP 2015
//
// SMBUS ACER AO722 sample (battery Sanyo AL10A31)
//
// Warning: this code implements 'only communication':
// <<< DO NOT READY FOR REPLACE REAL BATTERY >>>
//
// reference: http://smbus.org/specs/
//            http://smbus.org/specs/smbus110.pdf
//
#include <xc.h>
#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG1L
#pragma config PLLDIV = 1       // PLL Prescaler Selection bits (Divide by 5 (20 MHz oscillator input))
#pragma config CPUDIV = OSC1_PLL2// System Clock Postscaler Selection bits ([Primary Oscillator Src: /1][96 MHz PLL Src: /2])
#pragma config USBDIV = 1       // USB Clock Selection bit (used in Full-Speed USB mode only; UCFG:FSEN = 1) (USB clock source comes directly from the primary oscillator block with no postscale)

// CONFIG1H
#pragma config FOSC = HS   // HSPLL_HS Oscillator Selection bits (HS oscillator, PLL enabled (HSPLL))
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

// CONFIG2L
#pragma config PWRT = ON       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = ON         // Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
#pragma config BORV = 3         // Brown-out Reset Voltage bits (Minimum setting)
#pragma config VREGEN = ON      // USB Voltage Regulator Enable bit (USB voltage regulator enabled)

// CONFIG2H
#pragma config WDT = OFF        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)

// CONFIG3H
#pragma config CCP2MX = ON      // CCP2 MUX bit (CCP2 input/output is multiplexed with RC1)
#pragma config PBADEN = OFF     // PORTB A/D Enable bit (PORTB<4:0> pins are configured as digital I/O on Reset)
#pragma config LPT1OSC = OFF    // Low-Power Timer 1 Oscillator Enable bit (Timer1 configured for higher power operation)
#pragma config MCLRE = ON       // MCLR Pin Enable bit (MCLR pin enabled; RE3 input pin disabled)

// CONFIG4L
#pragma config STVREN = ON      // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = OFF         // Single-Supply ICSP Enable bit (Single-Supply ICSP enabled)
#pragma config XINST = OFF      // Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

// CONFIG5L
#pragma config CP0 = ON         // Code Protection bit (Block 0 (000800-001FFFh) is code-protected)
#pragma config CP1 = ON         // Code Protection bit (Block 1 (002000-003FFFh) is code-protected)
#pragma config CP2 = ON         // Code Protection bit (Block 2 (004000-005FFFh) is code-protected)
#pragma config CP3 = ON         // Code Protection bit (Block 3 (006000-007FFFh) is code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot block (000000-0007FFh) is not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM is not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000800-001FFFh) is not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) is not write-protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (004000-005FFFh) is not write-protected)
#pragma config WRT3 = OFF       // Write Protection bit (Block 3 (006000-007FFFh) is not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) are not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot block (000000-0007FFh) is not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM is not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000800-001FFFh) is not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) is not protected from table reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (004000-005FFFh) is not protected from table reads executed in other blocks)
#pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (006000-007FFFh) is not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot block (000000-0007FFh) is not protected from table reads executed in other blocks)


#define BATT LATBbits.LATB3
#define LED_VD LATBbits.LATB4
#define LED_VM LATBbits.LATB5

#define MWA      0b00001001 // 0x09 master write last was address
#define MWD      0b00101001 // 0x29 master write last was data
#define MRA      0b00001101 // 0x0d master read last was address
#define MRD      0b00101100 // 0x2c master write last was data
#define MLR      0b00101000 // 0x28 MASTER SEND LOGIC RESET

//typedef enum _BATT_STATES   // BATT 100% - AC on
//{
//    BATT_STATE_00_B0              = 8,     // 5.1.1. ManufacturerAccess()
//    BATT_STATE_00_B1              = 66,   // 5.1.1.  ManufacturerAccess()
//
//    BATT_STATE_03_B0              = 0,     // 5.1.4. BatteryMode()
//    BATT_STATE_03_B1              = 96,    // 5.1.4.  BatteryMode()
//
//    BATT_STATE_08_B0              = 225,   // 5.1.9. Temperature()
//    BATT_STATE_08_B1              = 11,    // 5.1.9.  Temperature()
//
//    BATT_STATE_09_B0              = 197,    // 5.1.10. Voltage()
//    BATT_STATE_09_B1              = 0,    // 5.1.10. Voltage()
//
//    BATT_STATE_0A_B0              = 110,   // 5.1.17. FullChargeCapacity()
//    BATT_STATE_0A_B1              = 3,     // 5.1.17. FullChargeCapacity()
//
//    BATT_STATE_0B_B0              = 0,   // 5.1.18. RunTimeToEmpty()
//    BATT_STATE_0B_B1              = 0,     // 5.1.18. RunTimeToEmpty()
//
//    BATT_STATE_0D_B0              = 100,    // 5.1.14. RelativeStateOfCharge()
//    BATT_STATE_0D_B1              = 0,     // 5.1.14. RelativeStateOfCharge()
//
//    BATT_STATE_0F_B0              = 109,   // 5.1.16. RemainingCapacity()
//    BATT_STATE_0F_B1              = 3,     // 5.1.16. RemainingCapacity()
//
//    BATT_STATE_14_B0              = 0,   // 5.1.28. ManufacturerName()
//    BATT_STATE_14_B1              = 0,     // 5.1.28. ManufacturerName()
//
//    BATT_STATE_15_B0              = 0,     // 5.2.2. ChargingVoltage()
//    BATT_STATE_15_B1              = 0,     // 5.2.2.  ChargingVoltage()
//
//    BATT_STATE_16_B0              = 224,   // 5.1.21. BatteryStatus()
//    BATT_STATE_16_B1              = 64,     // 5.1.21. BatteryStatus()
//
//    BATT_STATE_17_B0              = 5,   // 5.1.22. CycleCount()
//    BATT_STATE_17_B1              = 0,     // 5.1.22. CycleCount()
//
//    BATT_STATE_18_B0              = 152,   // 5.1.24. DesignVoltage()
//    BATT_STATE_18_B1              = 8,     // 5.1.24. DesignVoltage()
//
//    BATT_STATE_19_B0              = 92,   // 5.1.24. DesignVoltage()
//    BATT_STATE_19_B1              = 43,     // 5.1.24. DesignVoltage()
//
//    BATT_STATE_1B_B0              = 176,   // 5.1.26. ManufactureDate()
//    BATT_STATE_1B_B1              = 62,     // 5.1.26. ManufactureDate()
//
//    BATT_STATE_1C_B0              = 189,   // 5.1.27. SerialNumber()
//    BATT_STATE_1C_B1              = 30,     // 5.1.27. SerialNumber()
//
//    BATT_STATE_20_B0              = 5,   // 5.1.28. ManufacturerName()
//    BATT_STATE_20_B1              = 83,     // 5.1.28. ManufacturerName()
//    BATT_STATE_20_B2              = 65,     // 5.1.28. ManufacturerName()
//    BATT_STATE_20_B3              = 78,     // 5.1.28. ManufacturerName()
//    BATT_STATE_20_B4              = 89,     // 5.1.28. ManufacturerName()
//    BATT_STATE_20_B5              = 79,     // 5.1.28. ManufacturerName()
//
//    BATT_STATE_21_B0              = 7,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B1              = 65,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B2              = 76,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B3              = 49,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B4              = 48,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B5              = 65,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B6              = 51,   // 5.1.29. DeviceName()
//    BATT_STATE_21_B7              = 49,   // 5.1.29. DeviceName()
//
//    BATT_STATE_3C_B0              = 0,     // Unknown Manufacturer data
//    BATT_STATE_3C_B1              = 0,     // Unknown Manufacturer data
//
//    BATT_STATE_3D_B0              = 87,    // Unknown Manufacturer data
//    BATT_STATE_3D_B1              = 16,    // Unknown Manufacturer data
//
//    BATT_STATE_3E_B0              = 39,    // Unknown Manufacturer data
//    BATT_STATE_3E_B1              = 16,    // Unknown Manufacturer data
//
//    BATT_STATE_3F_B0              = 72,     // Unknown Manufacturer data
//    BATT_STATE_3F_B1              = 16     // Unknown Manufacturer data
//
//} BATT_STATES;

typedef enum _BATT_STATES   // test
{
    BATT_STATE_00_B0              = 8,     // 5.1.1. ManufacturerAccess()
    BATT_STATE_00_B1              = 224,   // 5.1.1.  ManufacturerAccess()

    BATT_STATE_03_B0              = 0B10100000,     // 5.1.4. BatteryMode()
    BATT_STATE_03_B1              = 0B00000010,    // 5.1.4.  BatteryMode()

    BATT_STATE_08_B0              = 231,   // 5.1.9. Temperature()
    BATT_STATE_08_B1              = 11,    // 5.1.9.  Temperature()

    BATT_STATE_09_B0              = 229,    // 5.1.10. Voltage()
    BATT_STATE_09_B1              = 48,    // 5.1.10. Voltage()

    BATT_STATE_0A_B0              = 78,   // 5.1.17. FullChargeCapacity()
    BATT_STATE_0A_B1              = 2,     // 5.1.17. FullChargeCapacity()

    BATT_STATE_0B_B0              = 114,   // 5.1.18. RunTimeToEmpty()
    BATT_STATE_0B_B1              = 2,     // 5.1.18. RunTimeToEmpty()

    BATT_STATE_0D_B0              = 80,    // 5.1.14. RelativeStateOfCharge()
    BATT_STATE_0D_B1              = 0,     // 5.1.14. RelativeStateOfCharge()

    BATT_STATE_0F_B0              = 194,   // 5.1.16. RemainingCapacity()
    BATT_STATE_0F_B1              = 2,     // 5.1.16. RemainingCapacity()

    BATT_STATE_14_B0              = 148,   // 5.1.28. ManufacturerName()
    BATT_STATE_14_B1              = 2,     // 5.1.28. ManufacturerName()

    BATT_STATE_15_B0              = 56,     // 5.2.2. ChargingVoltage()
    BATT_STATE_15_B1              = 49,     // 5.2.2.  ChargingVoltage()

    BATT_STATE_16_B0              = 0B00000000,   // 5.1.21. BatteryStatus()
    BATT_STATE_16_B1              = 0B00000000,     // 5.1.21. BatteryStatus()

    BATT_STATE_17_B0              = 5,   // 5.1.22. CycleCount()
    BATT_STATE_17_B1              = 0,     // 5.1.22. CycleCount()

    BATT_STATE_18_B0              = 152,   // 5.1.24. DesignVoltage()
    BATT_STATE_18_B1              = 8,     // 5.1.24. DesignVoltage()

    BATT_STATE_19_B0              = 92,   // 5.1.24. DesignVoltage()
    BATT_STATE_19_B1              = 43,     // 5.1.24. DesignVoltage()

    BATT_STATE_1B_B0              = 176,   // 5.1.26. ManufactureDate()
    BATT_STATE_1B_B1              = 62,     // 5.1.26. ManufactureDate()

    BATT_STATE_1C_B0              = 189,   // 5.1.27. SerialNumber()
    BATT_STATE_1C_B1              = 30,     // 5.1.27. SerialNumber()

    BATT_STATE_20_B0              = 5,   // 5.1.28. ManufacturerName()
    BATT_STATE_20_B1              = 83,     // 5.1.28. ManufacturerName()
    BATT_STATE_20_B2              = 65,     // 5.1.28. ManufacturerName()
    BATT_STATE_20_B3              = 78,     // 5.1.28. ManufacturerName()
    BATT_STATE_20_B4              = 89,     // 5.1.28. ManufacturerName()
    BATT_STATE_20_B5              = 79,     // 5.1.28. ManufacturerName()

    BATT_STATE_21_B0              = 7,   // 5.1.29. DeviceName()
    BATT_STATE_21_B1              = 65,   // 5.1.29. DeviceName()
    BATT_STATE_21_B2              = 76,   // 5.1.29. DeviceName()
    BATT_STATE_21_B3              = 49,   // 5.1.29. DeviceName()
    BATT_STATE_21_B4              = 48,   // 5.1.29. DeviceName()
    BATT_STATE_21_B5              = 65,   // 5.1.29. DeviceName()
    BATT_STATE_21_B6              = 51,   // 5.1.29. DeviceName()
    BATT_STATE_21_B7              = 49,   // 5.1.29. DeviceName()

    BATT_STATE_3C_B0              = 0,     // Unknown Manufacturer data
    BATT_STATE_3C_B1              = 0,     // Unknown Manufacturer data

    BATT_STATE_3D_B0              = 100,    // Unknown Manufacturer data
    BATT_STATE_3D_B1              = 16,    // Unknown Manufacturer data

    BATT_STATE_3E_B0              = 40,    // Unknown Manufacturer data
    BATT_STATE_3E_B1              = 16,    // Unknown Manufacturer data

    BATT_STATE_3F_B0              = 89,     // Unknown Manufacturer data
    BATT_STATE_3F_B1              = 16     // Unknown Manufacturer data

} BATT_STATES;

unsigned char RX_COMMAND, TX_DATA, TX_INDEX;

//Function Prototypes
void I2CWrite(unsigned char);
void Initialize(void);


unsigned char SendData(unsigned char COMMAND, unsigned char BYTE)
{
                if(COMMAND==0x00)
                {
                    if(BYTE==0) return BATT_STATE_00_B0;    //write back the index of status requested
                    else return BATT_STATE_00_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x03)
                {
                    if(BYTE==0) return BATT_STATE_03_B0;    //write back the index of status requested
                    else return BATT_STATE_03_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x08)
                {
                    if(BYTE==0) return BATT_STATE_08_B0;    //write back the index of status requested
                    else return BATT_STATE_08_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x09)
                {
                    if(BYTE==0) return BATT_STATE_09_B0;    //write back the index of status requested
                    else return BATT_STATE_09_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x0A)
                {
                    if(BYTE==0) return BATT_STATE_0A_B0;    //write back the index of status requested
                    else return BATT_STATE_0A_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x0B)
                {
                    if(BYTE==0) return BATT_STATE_0B_B0;    //write back the index of status requested
                    else return BATT_STATE_0B_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x0D)
                {
                    if(BYTE==0) return BATT_STATE_0D_B0;    //write back the index of status requested
                    else return BATT_STATE_0D_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x0F)
                {
                    if(BYTE==0) return BATT_STATE_0F_B0;    //write back the index of status requested
                    else return BATT_STATE_0F_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x14)
                {
                    if(BYTE==0) return BATT_STATE_14_B0;    //write back the index of status requested
                    else return BATT_STATE_14_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x15)
                {
                    if(BYTE==0) return BATT_STATE_15_B0;    //write back the index of status requested
                    else return BATT_STATE_15_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x16)
                {
                    if(BYTE==0) return BATT_STATE_16_B0;    //write back the index of status requested
                    else return BATT_STATE_16_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x17)
                {
                    if(BYTE==0) return BATT_STATE_17_B0;    //write back the index of status requested
                    else return BATT_STATE_17_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x18)
                {
                    if(BYTE==0) return BATT_STATE_18_B0;    //write back the index of status requested
                    else return BATT_STATE_18_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x19)
                {
                    if(BYTE==0) return BATT_STATE_19_B0;    //write back the index of status requested
                    else return BATT_STATE_19_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x1B)
                {
                    if(BYTE==0) return BATT_STATE_1B_B0;    //write back the index of status requested
                    else return BATT_STATE_1B_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x1C)
                {
                    if(BYTE==0) return BATT_STATE_1C_B0;    //write back the index of status requested
                    else return BATT_STATE_1C_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x20)
                {
                    if(BYTE==0) return BATT_STATE_20_B0;    //write back the index of status requested
                    else if(BYTE==1) return BATT_STATE_20_B1;    //write back the index of status requested
                    else if(BYTE==2) return BATT_STATE_20_B2;    //write back the index of status requested
                    else if(BYTE==3) return BATT_STATE_20_B3;    //write back the index of status requested
                    else if(BYTE==4) return BATT_STATE_20_B4;    //write back the index of status requested
                    else return BATT_STATE_20_B5;    //write back the index of status requested
                }
                else if(COMMAND==0x21)
                {
                    if(BYTE==0) return BATT_STATE_21_B0;    //write back the index of status requested
                    else if(BYTE==1) return BATT_STATE_21_B1;    //write back the index of status requested
                    else if(BYTE==2) return BATT_STATE_21_B2;    //write back the index of status requested
                    else if(BYTE==3) return BATT_STATE_21_B3;    //write back the index of status requested
                    else if(BYTE==4) return BATT_STATE_21_B4;    //write back the index of status requested
                    else if(BYTE==5) return BATT_STATE_21_B5;    //write back the index of status requested
                    else if(BYTE==6) return BATT_STATE_21_B6;    //write back the index of status requested
                    else return BATT_STATE_21_B7;    //write back the index of status requested
                }
                else if(COMMAND==0x3C)
                {
                    if(BYTE==0) return BATT_STATE_3C_B0;    //write back the index of status requested
                    else return BATT_STATE_3C_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x3D)
                {
                    if(BYTE==0) return BATT_STATE_3D_B0;    //write back the index of status requested
                    else return BATT_STATE_3D_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x3E)
                {
                    if(BYTE==0) return BATT_STATE_3E_B0;    //write back the index of status requested
                    else return BATT_STATE_3E_B1;    //write back the index of status requested
                }
                else if(COMMAND==0x3F)
                {
                    if(BYTE==0) return BATT_STATE_3F_B0;    //write back the index of status requested
                    else return BATT_STATE_3F_B1;    //write back the index of status requested
                }
    return 0;
}

void interrupt isr(void)
{
    //This isr routine uses one if block as opposed to multiple ones.
    //Using only one "if" avoids run time errors.  We handle only one interrupt at a time
    //all variables that are modified by an ISR must be declared as volatile
    /* Determine which flag generated the interrupt */
//    static char DAStatus=0;
    unsigned char j;

    if(SSPIF)  //I2C interrupt handler
    {
        SSPIF = 0;      //Clear interrupt flag

        LED_VD = 0;
        LED_VM = 0;

        //transmit data to master
        if (SSPSTATbits.R_W == 1){             // Read request from master
          TX_DATA = SendData(RX_COMMAND, TX_INDEX);
          SSPBUF = TX_DATA;                // Get data to send
          LED_VD = 1;
          SSPCON1bits.CKP = 1;                  // Release SCL line
          j = SSPBUF;                      // That's it
          TX_INDEX++;
          return;
        }
        if (SSPSTATbits.BF == 0){              // all done,
          j = SSPBUF;                      // Nothing in buffer so exit
          return;
        }

        //recieve data from master
        if (SSPSTATbits.D_A == 1){             // Data [not address]
          RX_COMMAND = SSPBUF;               // get data --> COMMAND
          TX_INDEX = 0;

//          if(RX_COMMAND==13)
//          {
            LED_VM = TX_DATA & 1;
//          }
          j = SSPBUF;                      // read buffer to clear flag [address]
          return;
        }
    }

    j = SSPBUF;                      // read buffer to clear flag [address]
}
void main(void){
    Initialize();
}
void I2CWrite(unsigned char data){
    while(BF);      //wait while buffer is full
    do{
        WCOL = 0;           //clear write collision flag
        SSPBUF = data;
    }while (WCOL);           //do until write collision flag is clear
    if (SEN) CKP = 1;           //release the SCL line
}

// Delay by specified number of milliseconds
void DelayMs(unsigned int n)
{
    while(n--) __delay_ms(1);
}

void Initialize(void)
{
    DelayMs(1000);

    SSPCON1=0;  // 0 = Disables serial port and configures these pins as I/O port pins

    LATA = 0;
    LATB = 0;
    LATC = 0;

    SSPCON1=0B00110110;
    SSPCON2=0B00000000;
//    OpenI2C(SLAVE_7, SLEW_OFF);
    SSPADD = 22; //SSPADD contains I2C device address in SLAVE mode
    SSPSTATbits.CKE = 1; // 1 = Enable SMBus specific inputs
    SSPCON1bits.CKP = 1; // 1 = Release clock line SCL

    TRISA = 0;
    TRISB = 255;
    TRISC = 0;

    TRISBbits.RB3 = 0;
    TRISBbits.RB4 = 0;
    TRISBbits.RB5 = 0;

    BATT=1;
    DelayMs(1000);
    BATT=0;

    LED_VD=0;
    LED_VM=0;

    unsigned char data;
    data = SSPBUF;
    if(SSPOV)SSPOV = 0;              //clear receive overflow indicator
    if (SEN) CKP = 1;           //release the SCL line

    /* Enable interrupts */
    SSPIF  = 0;   //Clear MSSP interrupt flag
    SSPIE  = 1;   //I2C interrupt enable
    PEIE    = 1;   // Enable Peripheral interrupts
    GIE     = 1;   // Enable global interrupts

    while(1)
    {

    }
}